<!-- 
片段名称： 文章详情界面
作者:     ssc
时间：     2020-8-8
功能：    文章详情界面，展示文章以及评论内容
修改记录： 
--> 

<!-- 仅用来测试！！！！！！！！！！！！！ -->
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load staticfiles %}
{% load like_tags %}
{% load collect_tags %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
文章详情
{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}

<!-- 文章详情 -->
<div class="container">
    <div class="row">
        <!-- 标题及作者 -->
        <h1 class="col-12 mt-4 mb-4">{{ article.title }}</h1>
        <div class="col-12 alert alert-success">
            <div>
                版块：{{ article.column }}
            </div>
            <div>
                作者：{{ article.author }}
                {% if user == article.author %}
                    <a href="#" onclick="confirm_delete_article()">删除文章</a><!--要修改删除url，去下面scripe中找confirm_delete中的location.href-->
                    <a href="{% url 'article:article_update' article.id %}">编辑文章</a>
                {% endif %}
            </div>
        </div>
         {% if article.attachment %}
            <div style="color:gray">
                附件名称:   {{ article.attachment }}
            </div>
            {% endif %}
        <!-- 文章正文 -->
        <div class="col-12">
            <p>{{ article.body|safe }}</p>
        </div>
    </div>

        <!-- 点赞按钮 -->
        <div class="mt-4">
            <div class="d-flex justify-content-center">
                 {% if article.attachment %}
            <button type="button" class="btn btn-primary mr-4" onclick="window.location.href='{% url 'article:download_file' article.id %}'">下载附件</button>
            {% endif %}
                {% if user.is_authenticated %}
                <button type="button" class="btn btn-link" style="text-decoration:none;color:darkslategrey;" onclick="like_change('articlepost', {{ article.id }})">
                    {% if article|add_arg:request.user|call:"article_is_liked" %}
                    <span id="like-container"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="like-container"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                    {% endif %}
                    点赞
                    <span id="likes_number">{% get_likes_num article %}</span>
                </button>

                <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('articlepost', {{ article.id }})">
                    {% if article|add_arg:request.user|call:"article_is_collected" %}
                    <span id="collect-container"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                    {% else %}
                    <span id="collect-container"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                    {% endif %}
                    收藏
                    <span id="collect_number">{% get_collect_num article %}</span>
                </button>
                {% endif %}
            </div>
        </div>

    <div class="col-9">

        <!-- 发表评论 -->
    <hr>
    {% if user.is_authenticated %}
        <div>
            <form
                action="{% url 'comment:post_comment' article.id %}"
                method="POST"
            >
            {% csrf_token %}
                <div class="form-group">
                    <label for="body">
                        <strong>
                            我也要发言：
                        </strong>
                    </label>

                    <div>
                        {{ comment_form.media }}
                        {{ comment_form.body }}
                    </div>
                </div>
                <!-- 提交按钮 -->
                <button type="submit" class="btn btn-primary ">发送</button>
            </form>
        </div>
        <br>
    {% else %}
        <br>
        <h5 class="row justify-content-center">
            请<a href="{% url 'userprofile:login' %}">登录</a>后回复
        </h5>
        <br>
    {% endif %}





<!-- 改动 显示评论 部分 -->
<!-- 不要漏了 load mptt_tags！ -->
{% load mptt_tags %}
<h4>共有{{ comments.count }}条评论</h4>
<div class="row">
    <!-- 遍历树形结构 -->
    {% recursetree comments %}
        <!-- 给 node 取个别名 comment -->
        {% with comment=node %}
            <div class="{% if comment.reply_to %}
                        offset-1 col-11
                        {% else %}
                        col-12
                        {% endif %}"
            >
                <hr>
                <p>
                    <strong style="color: pink">
                        {{ comment.user }}
                    </strong>
<!--这个是孩子显示的格式    -->
                    {% if comment.reply_to %}
                        <i class="far fa-arrow-alt-circle-right"
                           style="color: cornflowerblue;"
                        ></i>
                        <strong style="color: pink">
                            {{ comment.reply_to }}
                        </strong>
                     {% if user == comment.user %}
                    <strong class="btn btn-light btn-sm text-muted">
                        <!--
                        <a href="{% url 'comment:comment_delete' article.id comment.id %}">删除回复</a>-->
                        <a href="#" onclick="confirm_delete_comment({{ article.id }}, {{ comment.id }})">删除回复</a>
                        </strong>
                     <button type="button"

                            class="btn btn-light btn-sm text-muted"
                            onclick="load_modal2({{ article.id }}, {{ comment.id }})"
                            >
                        修改回复
                        </button>
                    {% endif %}
<!--                    这个else是第一个评论的人显示的删除评论-->
                    {% else %}
                    {% if user == comment.user %}
                      <strong  class="btn btn-light btn-sm text-muted">
                        <a href="#" onclick="confirm_delete_comment({{ article.id }}, {{ comment.id }})">删除评论</a>
                            <!-- <a href="#" onclick="confirm_delete_comment({{ article.id }}, {{ comment.id }})">删除评论</a> -->
                        </strong>
                    <button type="button"

                            class="btn btn-light btn-sm text-muted"
                            onclick="load_modal2({{ article.id }}, {{ comment.id }})"
                            >
                        修改评论
                        </button>
                    {% endif %}
                    {% endif %}

                </p>
                <div>{{ comment.body|safe }}</div>

                <div>
                    <span style="color: gray">
                        {{ comment.created|date:"Y-m-d H:i" }}
                    </span>

                    <!-- 加载 modal 的按钮 -->
                    {% if user.is_authenticated %}
                    <li>
                        <button type="button"
                            class="btn btn-light btn-sm text-muted"
                            onclick="load_modal({{ article.id }}, {{ comment.id }})"
                            >
                        回复
                        </button>

                        <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="like_change('comment', {{ comment.id }})">
                        {% if comment|add_arg:request.user|call:"comment_is_liked" %}
                            <span id="like-container{{comment.id}}"><i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i></span>
                        {% else %}
                            <span id="like-container{{comment.id}}"><i id="like-icon" class="far fa-heart" style="font-size:20px;"></i></span>
                        {% endif %}
                            点赞
                            <span id="likes_number{{comment.id}}">{% get_likes_num comment %}</span>
                        </button>

                        <button type="button" class="btn btn-link btn-sm" style="text-decoration:none;color:darkslategrey;" onclick="collect_change('comment', {{ comment.id }})">
                        {% if comment|add_arg:request.user|call:"comment_is_collected" %}
                            <span id="collect-container{{comment.id}}"><i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i></span>
                        {% else %}
                            <span id="collect-container{{comment.id}}"><i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i></span>
                        {% endif %}
                            收藏
                        <span id="collect_number{{comment.id}}">{% get_collect_num comment %}</span>
                        </button>
                    </li>

                    {% else %}
                    <a class="btn btn-light btn-sm text-muted"
                       href="{% url 'userprofile:login' %}"
                       >
                        回复
                    </a>
                    {% endif %}
                </div>

                <!-- Modal -->
                <div class="modal fade"
                     id="comment_{{ comment.id }}"
                     tabindex="-1"
                     role="dialog"
                     aria-labelledby="CommentModalCenter"
                     aria-hidden="true"
                >
                    <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
                        <div class="modal-content" style="height: 480px">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalCenterTitle">回复 {{ comment.user }}：</h5>
                            </div>
                            <div class="modal-body" id="modal_body_{{ comment.id }}" ></div>
                        </div>

                    </div>
                </div>
                <!-- Modal2 -->
                <div class="modal fade"
                     id="2comment_{{ comment.id }}"
                     tabindex="-1"
                     role="dialog"
                     aria-labelledby="CommentModalCenter"
                     aria-hidden="true"
                >
                    <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
                        <div class="modal-content" style="height: 480px">
                            <div class="modal-header">
                                <h5 class="modal-title" id="2exampleModalCenterTitle">修改：</h5>
                            </div>
                            <div class="modal-body" id="2modal_body_{{ comment.id }}" ></div>
                        </div>

                    </div>
                </div>

                {% if not comment.is_leaf_node %}
                    <div class="children">
                        {{ children }}
                    </div>
                {% endif %}
            </div>


        {% endwith %}
    {% endrecursetree %}
</div>



    </div>
</div>


{% if messages %}
<!--信息弹框形式-->
<script>
    {% for msg in messages %}
        alert('{{ msg.message }}');
    {% endfor %}
</script>
{% endif %}

{% endblock content %}

{% block script %}
<script>
    // 删除文章的函数
    function confirm_delete_article() {
        // 调用layer弹窗组件
        layer.open({
            // 弹窗标题
            title: "确认删除",
            // 正文
            content: "确认删除这篇文章吗？",
            // 点击确定按钮后调用的回调函数
            yes: function(index, layero) {
                // 指定应当前往的 url
                location.href="{% url 'article:article_delete' article.id %}"
            },
        });
    }
</script>
<script>
    // 删除文章的函数
    function confirm_delete_comment(article_id, comment_id) {
        // 调用layer弹窗组件
        layer.open({
            // 弹窗标题
            title: "确认删除",
            // 正文
            content: "确认删除该回复吗？",
            // 点击确定按钮后调用的回调函数
            yes: function(index, layero) {
                // 指定应当前往的 url
                // console.log(comment.id);
                var url = "{% url 'comment:comment_delete' 210000000 220000000 %}";
                url = url.replace(/210000000/, article_id);
                url = url.replace(/220000000/, comment_id);
                location.href=url
            },
        });
    }
</script>
<script>
    function like_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'like:like_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost"){
                    if(data.is_liked){
                        $("#like-container").html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $("#like-container").html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    $("#likes_number").html(data.likes_num);
                }
                else{
                    var container = '#like-container'+object_id;
                    if(data.is_liked){
                        $(container).html('<i id="like-icon" class="fas fa-heart" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="like-icon" class="far fa-heart" style="font-size:20px;"></i>');
                    }
                    var number = '#likes_number'+object_id;
                    $(number).html(data.likes_num);
                }
            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }

    function collect_change(content_type, object_id) {
        $.ajax({
            url: "{% url 'collect:collect_change' %}",
            type: 'GET',
            data: {
                content_type: content_type,
                object_id: object_id,
            },
            cache: false,
            success: function (data) {
                console.log(data);
                if(content_type=="articlepost" || content_type=="questionpost") {
                    if (data.is_collected) {
                        $("#collect-container").html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    } else {
                        $("#collect-container").html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    $("#collect_number").html(data.collect_num);
                }
                else{
                    var container = '#collect-container'+object_id;
                    if(data.is_collected){
                        $(container).html('<i id="collect-icon" class="fas fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    else{
                        $(container).html('<i id="collect-icon" class="far fa-paper-plane" style="font-size:20px;"></i>');
                    }
                    var number = '#collect_number'+object_id;
                    $(number).html(data.collect_num);
                }
            },
            error: function (xhr) {
                console.log(xhr);
            }
        });
    }
</script>

<script>
    // 加载 modal
    function load_modal(article_id, comment_id) {
        let modal_body = '#modal_body_' + comment_id;
        let modal_id = '#comment_' + comment_id;
        
        // 加载编辑器
        if ($(modal_body).children().length === 0) {
            let content = '<iframe src="/comment/post-comment/' + 
                article_id + 
                '/' + 
                comment_id + 
                '"' + 
                ' frameborder="0" style="width: 100%; height: 100%;" id="iframe_' + 
                comment_id + 
                '"></iframe>';
            $(modal_body).append(content);
        };

        $(modal_id).modal('show');
    }
</script>

<script>
    // 加载 modal
    function load_modal2(article_id, comment_id) {
        let modal_body = '#2modal_body_' + comment_id;
        let modal_id = '#2comment_' + comment_id;

        // 加载编辑器
        if ($(modal_body).children().length === 0) {
            let content = '<iframe src="/comment/update-comment/' +
                article_id +
                '/' +
                comment_id +
                '"' +
                ' frameborder="0" style="width: 100%; height: 100%;" id="iframe_' +
                comment_id +
                '"></iframe>';
            $(modal_body).append(content);
        };

        $(modal_id).modal('show');
    }
</script>
<script src="{% static 'ckeditor/ckeditor/plugins/prism/lib/prism/prism_patched.min.js' %}"></script>
<link rel="stylesheet" href="{% static 'prism/prism.css' %}">
{% endblock script %}
